diff --git a/src/include/access/nbtxlog.h b/src/include/access/nbtxlog.h
index 3a78ec27fe8..8918d675dce 100644
--- a/src/include/access/nbtxlog.h
+++ b/src/include/access/nbtxlog.h
@@ -46,7 +46,7 @@
 /*
  * All that we need to regenerate the meta-data page
  */
-typedef struct xl_btree_metadata
+typedef struct PG_NO_PADDING xl_btree_metadata
 {
 	uint32		version;
 	BlockNumber root;
@@ -55,6 +55,8 @@ typedef struct xl_btree_metadata
 	uint32		fastlevel;
 	uint32		last_cleanup_num_delpages;
 	bool		allequalimage;
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 } xl_btree_metadata;
 
 /*
@@ -76,7 +78,7 @@ typedef struct xl_btree_metadata
  * that was split as an extra step.  Also, recovery generates a "final"
  * newitem.  See _bt_swap_posting() for details on posting list splits.
  */
-typedef struct xl_btree_insert
+typedef struct PG_NO_PADDING xl_btree_insert
 {
 	OffsetNumber offnum;
 
@@ -84,7 +86,7 @@ typedef struct xl_btree_insert
 	/* NEW TUPLE ALWAYS FOLLOWS AT THE END */
 } xl_btree_insert;
 
-#define SizeOfBtreeInsert	(offsetof(xl_btree_insert, offnum) + sizeof(OffsetNumber))
+#define SizeOfBtreeInsert	sizeof(xl_btree_insert)
 
 /*
  * On insert with split, we save all the items going into the right sibling
@@ -150,15 +152,16 @@ typedef struct xl_btree_insert
  * Backup Blk 2: next block (orig page's rightlink), if any
  * Backup Blk 3: child's left sibling, if non-leaf split
  */
-typedef struct xl_btree_split
+typedef struct PG_NO_PADDING xl_btree_split
 {
 	uint32		level;			/* tree level of page being split */
 	OffsetNumber firstrightoff; /* first origpage item on rightpage */
 	OffsetNumber newitemoff;	/* new item's offset */
 	uint16		postingoff;		/* offset inside orig posting tuple */
+	pg_padding_2(pg_pad);
 } xl_btree_split;
 
-#define SizeOfBtreeSplit	(offsetof(xl_btree_split, postingoff) + sizeof(uint16))
+#define SizeOfBtreeSplit	sizeof(xl_btree_split)
 
 /*
  * When page is deduplicated, consecutive groups of tuples with equal keys are
@@ -167,14 +170,14 @@ typedef struct xl_btree_split
  * The WAL record represents a deduplication pass for a leaf page.  An array
  * of BTDedupInterval structs follows.
  */
-typedef struct xl_btree_dedup
+typedef struct PG_NO_PADDING xl_btree_dedup
 {
 	uint16		nintervals;
 
 	/* DEDUPLICATION INTERVALS FOLLOW */
 } xl_btree_dedup;
 
-#define SizeOfBtreeDedup 	(offsetof(xl_btree_dedup, nintervals) + sizeof(uint16))
+#define SizeOfBtreeDedup	sizeof(xl_btree_dedup)
 
 /*
  * This is what we need to know about page reuse within btree.  This record
@@ -183,16 +186,19 @@ typedef struct xl_btree_dedup
  * Note that we must include a RelFileLocator in the record because we don't
  * actually register the buffer with the record.
  */
-typedef struct xl_btree_reuse_page
+typedef struct PG_NO_PADDING xl_btree_reuse_page
 {
 	RelFileLocator locator;
 	BlockNumber block;
 	FullTransactionId snapshotConflictHorizon;
 	bool		isCatalogRel;	/* to handle recovery conflict during logical
 								 * decoding on standby */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
+	pg_padding_4(pg_pad4);
 } xl_btree_reuse_page;
 
-#define SizeOfBtreeReusePage	(offsetof(xl_btree_reuse_page, isCatalogRel) + sizeof(bool))
+#define SizeOfBtreeReusePage	sizeof(xl_btree_reuse_page)
 
 /*
  * xl_btree_vacuum and xl_btree_delete records describe deletion of index
@@ -220,7 +226,7 @@ typedef struct xl_btree_reuse_page
  * Updates are only used when there will be some remaining TIDs left by the
  * REDO routine.  Otherwise the posting list tuple just gets deleted outright.
  */
-typedef struct xl_btree_vacuum
+typedef struct PG_NO_PADDING xl_btree_vacuum
 {
 	uint16		ndeleted;
 	uint16		nupdated;
@@ -234,15 +240,17 @@ typedef struct xl_btree_vacuum
 	 */
 } xl_btree_vacuum;
 
-#define SizeOfBtreeVacuum	(offsetof(xl_btree_vacuum, nupdated) + sizeof(uint16))
+#define SizeOfBtreeVacuum	sizeof(xl_btree_vacuum)
 
-typedef struct xl_btree_delete
+typedef struct PG_NO_PADDING xl_btree_delete
 {
 	TransactionId snapshotConflictHorizon;
 	uint16		ndeleted;
 	uint16		nupdated;
 	bool		isCatalogRel;	/* to handle recovery conflict during logical
 								 * decoding on standby */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 
 	/*----
 	 * In payload of blk 0 :
@@ -253,7 +261,7 @@ typedef struct xl_btree_delete
 	 */
 } xl_btree_delete;
 
-#define SizeOfBtreeDelete	(offsetof(xl_btree_delete, isCatalogRel) + sizeof(bool))
+#define SizeOfBtreeDelete	sizeof(xl_btree_delete)
 
 /*
  * The offsets that appear in xl_btree_update metadata are offsets into the
@@ -261,14 +269,14 @@ typedef struct xl_btree_delete
  * 0-based.  The page offset number for the original posting list tuple comes
  * from the main xl_btree_vacuum/xl_btree_delete record.
  */
-typedef struct xl_btree_update
+typedef struct PG_NO_PADDING xl_btree_update
 {
 	uint16		ndeletedtids;
 
 	/* POSTING LIST uint16 OFFSETS TO A DELETED TID FOLLOW */
 } xl_btree_update;
 
-#define SizeOfBtreeUpdate	(offsetof(xl_btree_update, ndeletedtids) + sizeof(uint16))
+#define SizeOfBtreeUpdate	sizeof(xl_btree_update)
 
 /*
  * This is what we need to know about marking an empty subtree for deletion.
@@ -280,9 +288,10 @@ typedef struct xl_btree_update
  * Backup Blk 0: leaf block
  * Backup Blk 1: top parent
  */
-typedef struct xl_btree_mark_page_halfdead
+typedef struct PG_NO_PADDING xl_btree_mark_page_halfdead
 {
 	OffsetNumber poffset;		/* deleted tuple id in parent page */
+	pg_padding_2(pg_pad);
 
 	/* information needed to recreate the leaf page: */
 	BlockNumber leafblk;		/* leaf block ultimately being deleted */
@@ -291,7 +300,7 @@ typedef struct xl_btree_mark_page_halfdead
 	BlockNumber topparent;		/* topmost internal page in the subtree */
 } xl_btree_mark_page_halfdead;
 
-#define SizeOfBtreeMarkPageHalfDead (offsetof(xl_btree_mark_page_halfdead, topparent) + sizeof(BlockNumber))
+#define SizeOfBtreeMarkPageHalfDead sizeof(xl_btree_mark_page_halfdead)
 
 /*
  * This is what we need to know about deletion of a btree page.  Note that we
@@ -307,11 +316,12 @@ typedef struct xl_btree_mark_page_halfdead
  * Backup Blk 3: leaf block (if different from target)
  * Backup Blk 4: metapage (if rightsib becomes new fast root)
  */
-typedef struct xl_btree_unlink_page
+typedef struct PG_NO_PADDING xl_btree_unlink_page
 {
 	BlockNumber leftsib;		/* target block's left sibling, if any */
 	BlockNumber rightsib;		/* target block's right sibling */
 	uint32		level;			/* target block's level */
+	pg_padding_4(pg_pad1);
 	FullTransactionId safexid;	/* target block's BTPageSetDeleted() XID */
 
 	/*
@@ -324,11 +334,12 @@ typedef struct xl_btree_unlink_page
 	BlockNumber leafleftsib;
 	BlockNumber leafrightsib;
 	BlockNumber leaftopparent;	/* next child down in the subtree */
+	pg_padding_4(pg_pad2);
 
 	/* xl_btree_metadata FOLLOWS IF XLOG_BTREE_UNLINK_PAGE_META */
 } xl_btree_unlink_page;
 
-#define SizeOfBtreeUnlinkPage	(offsetof(xl_btree_unlink_page, leaftopparent) + sizeof(BlockNumber))
+#define SizeOfBtreeUnlinkPage	sizeof(xl_btree_unlink_page)
 
 /*
  * New root log record.  There are zero tuples if this is to establish an
@@ -341,13 +352,13 @@ typedef struct xl_btree_unlink_page
  * Backup Blk 1: left child (if splitting an old root)
  * Backup Blk 2: metapage
  */
-typedef struct xl_btree_newroot
+typedef struct PG_NO_PADDING xl_btree_newroot
 {
 	BlockNumber rootblk;		/* location of new root (redundant with blk 0) */
 	uint32		level;			/* its tree level */
 } xl_btree_newroot;
 
-#define SizeOfBtreeNewroot	(offsetof(xl_btree_newroot, level) + sizeof(uint32))
+#define SizeOfBtreeNewroot	sizeof(xl_btree_newroot)
 
 
 /*
diff --git a/src/include/access/spgist_private.h b/src/include/access/spgist_private.h
index ec6d6f5f74d..c05693846d8 100644
--- a/src/include/access/spgist_private.h
+++ b/src/include/access/spgist_private.h
@@ -292,14 +292,14 @@ typedef struct SpGistCache
  * opclasses.  Going forward, we will be using a fixed size of Datum so that
  * there's no longer any pressing reason to change this.
  */
-typedef struct SpGistInnerTupleData
+typedef struct PG_NO_PADDING SpGistInnerTupleData
 {
 	unsigned int tupstate:2,	/* LIVE/REDIRECT/DEAD/PLACEHOLDER */
 				allTheSame:1,	/* all nodes in tuple are equivalent */
 				nNodes:13,		/* number of nodes within inner tuple */
 				prefixSize:16;	/* size of prefix, or 0 if none */
 	uint16		size;			/* total size of inner tuple */
-	/* On most machines there will be a couple of wasted bytes here */
+	pg_padding_2(pg_pad);
 	/* prefix datum follows, then nodes */
 } SpGistInnerTupleData;
 
@@ -382,7 +382,7 @@ typedef SpGistNodeTupleData *SpGistNodeTuple;
  * restriction only adds bytes for a NULL leaf datum; otherwise alignment
  * restrictions force it anyway.)
  */
-typedef struct SpGistLeafTupleData
+typedef struct PG_NO_PADDING SpGistLeafTupleData
 {
 	unsigned int tupstate:2,	/* LIVE/REDIRECT/DEAD/PLACEHOLDER */
 				size:30;		/* large enough for any palloc'able value */
diff --git a/src/include/access/spgxlog.h b/src/include/access/spgxlog.h
index c257408be66..fc1431407fd 100644
--- a/src/include/access/spgxlog.h
+++ b/src/include/access/spgxlog.h
@@ -33,17 +33,19 @@
  * need to be valid.  spgxlogState carries the required info in xlog records.
  * (See fillFakeState in spgxlog.c for more comments.)
  */
-typedef struct spgxlogState
+typedef struct PG_NO_PADDING spgxlogState
 {
 	TransactionId redirectXid;
 	bool		isBuild;
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 } spgxlogState;
 
 /*
  * Backup Blk 0: destination page for leaf tuple
  * Backup Blk 1: parent page (if any)
  */
-typedef struct spgxlogAddLeaf
+typedef struct PG_NO_PADDING spgxlogAddLeaf
 {
 	bool		newPage;		/* init dest page? */
 	bool		storesNulls;	/* page is in the nulls tree? */
@@ -61,17 +63,19 @@ typedef struct spgxlogAddLeaf
  * Backup Blk 1: destination leaf page
  * Backup Blk 2: parent page
  */
-typedef struct spgxlogMoveLeafs
+typedef struct PG_NO_PADDING spgxlogMoveLeafs
 {
 	uint16		nMoves;			/* number of tuples moved from source page */
 	bool		newPage;		/* init dest page? */
 	bool		replaceDead;	/* are we replacing a DEAD source tuple? */
 	bool		storesNulls;	/* pages are in the nulls tree? */
+	pg_padding_1(pg_pad1);
 
 	/* where the parent downlink is */
 	OffsetNumber offnumParent;
 	uint16		nodeI;
 
+	pg_padding_2(pg_pad2);
 	spgxlogState stateSrc;
 
 	/*----------
@@ -96,7 +100,7 @@ typedef struct spgxlogMoveLeafs
  * Backup Blk 2: where parent downlink is, if updated and different from
  *				 the old and new
  */
-typedef struct spgxlogAddNode
+typedef struct PG_NO_PADDING spgxlogAddNode
 {
 	/*
 	 * Offset of the original inner tuple, in the original page (on backup
@@ -127,6 +131,7 @@ typedef struct spgxlogAddNode
 
 	uint16		nodeI;
 
+	pg_padding_2(pg_pad);
 	spgxlogState stateSrc;
 
 	/*
@@ -138,7 +143,7 @@ typedef struct spgxlogAddNode
  * Backup Blk 0: where the prefix tuple goes
  * Backup Blk 1: where the postfix tuple goes (if different page)
  */
-typedef struct spgxlogSplitTuple
+typedef struct PG_NO_PADDING spgxlogSplitTuple
 {
 	/* where the prefix tuple goes */
 	OffsetNumber offnumPrefix;
@@ -162,9 +167,10 @@ typedef struct spgxlogSplitTuple
  * Backup Blk 2: Inner page
  * Backup Blk 3: Parent page (if any, and different from Inner)
  */
-typedef struct spgxlogPickSplit
+typedef struct PG_NO_PADDING spgxlogPickSplit
 {
 	bool		isRootSplit;
+	pg_padding_1(pg_pad1);
 
 	uint16		nDelete;		/* n to delete from Src */
 	uint16		nInsert;		/* n to insert on Src and/or Dest */
@@ -179,9 +185,11 @@ typedef struct spgxlogPickSplit
 
 	/* where the parent downlink is, if any */
 	bool		innerIsParent;	/* is parent the same as inner page? */
+	pg_padding_1(pg_pad2);
 	OffsetNumber offnumParent;
 	uint16		nodeI;
 
+	pg_padding_2(pg_pad3);
 	spgxlogState stateSrc;
 
 	/*----------
@@ -198,7 +206,7 @@ typedef struct spgxlogPickSplit
 
 #define SizeOfSpgxlogPickSplit offsetof(spgxlogPickSplit, offsets)
 
-typedef struct spgxlogVacuumLeaf
+typedef struct PG_NO_PADDING spgxlogVacuumLeaf
 {
 	uint16		nDead;			/* number of tuples to become DEAD */
 	uint16		nPlaceholder;	/* number of tuples to become PLACEHOLDER */
@@ -222,10 +230,11 @@ typedef struct spgxlogVacuumLeaf
 
 #define SizeOfSpgxlogVacuumLeaf offsetof(spgxlogVacuumLeaf, offsets)
 
-typedef struct spgxlogVacuumRoot
+typedef struct PG_NO_PADDING spgxlogVacuumRoot
 {
 	/* vacuum a root page when it is also a leaf */
 	uint16		nDelete;		/* number of tuples to delete */
+	pg_padding_2(pg_pad);
 
 	spgxlogState stateSrc;
 
@@ -235,13 +244,15 @@ typedef struct spgxlogVacuumRoot
 
 #define SizeOfSpgxlogVacuumRoot offsetof(spgxlogVacuumRoot, offsets)
 
-typedef struct spgxlogVacuumRedirect
+typedef struct PG_NO_PADDING spgxlogVacuumRedirect
 {
 	uint16		nToPlaceholder; /* number of redirects to make placeholders */
 	OffsetNumber firstPlaceholder;	/* first placeholder tuple to remove */
 	TransactionId snapshotConflictHorizon;	/* newest XID of removed redirects */
 	bool		isCatalogRel;	/* to handle recovery conflict during logical
 								 * decoding on standby */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 
 	/* offsets of redirect tuples to make placeholders follow */
 	OffsetNumber offsets[FLEXIBLE_ARRAY_MEMBER];
diff --git a/src/include/access/xact.h b/src/include/access/xact.h
index f0b4d795071..d9617b235bd 100644
--- a/src/include/access/xact.h
+++ b/src/include/access/xact.h
@@ -216,7 +216,7 @@ typedef struct SavedTransactionCharacteristics
 #define XactCompletionForceSyncCommit(xinfo) \
 	((xinfo & XACT_COMPLETION_FORCE_SYNC_COMMIT) != 0)
 
-typedef struct xl_xact_assignment
+typedef struct PG_NO_PADDING xl_xact_assignment
 {
 	TransactionId xtop;			/* assigned XID's top-level XID */
 	int			nsubxacts;		/* number of subtransaction XIDs */
@@ -242,7 +242,7 @@ typedef struct xl_xact_assignment
 
 /* sub-records for commit/abort */
 
-typedef struct xl_xact_xinfo
+typedef struct PG_NO_PADDING xl_xact_xinfo
 {
 	/*
 	 * Even though we right now only require two bytes of space in xinfo we
@@ -253,20 +253,20 @@ typedef struct xl_xact_xinfo
 	uint32		xinfo;
 } xl_xact_xinfo;
 
-typedef struct xl_xact_dbinfo
+typedef struct PG_NO_PADDING xl_xact_dbinfo
 {
 	Oid			dbId;			/* MyDatabaseId */
 	Oid			tsId;			/* MyDatabaseTableSpace */
 } xl_xact_dbinfo;
 
-typedef struct xl_xact_subxacts
+typedef struct PG_NO_PADDING xl_xact_subxacts
 {
 	int			nsubxacts;		/* number of subtransaction XIDs */
 	TransactionId subxacts[FLEXIBLE_ARRAY_MEMBER];
 } xl_xact_subxacts;
 #define MinSizeOfXactSubxacts offsetof(xl_xact_subxacts, subxacts)
 
-typedef struct xl_xact_relfilelocators
+typedef struct PG_NO_PADDING xl_xact_relfilelocators
 {
 	int			nrels;			/* number of relations */
 	RelFileLocator xlocators[FLEXIBLE_ARRAY_MEMBER];
@@ -280,7 +280,7 @@ typedef struct xl_xact_relfilelocators
  * frontend code, but the WAL format needs to be readable by frontend
  * programs.
  */
-typedef struct xl_xact_stats_item
+typedef struct PG_NO_PADDING xl_xact_stats_item
 {
 	int			kind;
 	Oid			dboid;
@@ -293,32 +293,32 @@ typedef struct xl_xact_stats_item
 	uint32		objid_hi;
 } xl_xact_stats_item;
 
-typedef struct xl_xact_stats_items
+typedef struct PG_NO_PADDING xl_xact_stats_items
 {
 	int			nitems;
 	xl_xact_stats_item items[FLEXIBLE_ARRAY_MEMBER];
 } xl_xact_stats_items;
 #define MinSizeOfXactStatsItems offsetof(xl_xact_stats_items, items)
 
-typedef struct xl_xact_invals
+typedef struct PG_NO_PADDING xl_xact_invals
 {
 	int			nmsgs;			/* number of shared inval msgs */
 	SharedInvalidationMessage msgs[FLEXIBLE_ARRAY_MEMBER];
 } xl_xact_invals;
 #define MinSizeOfXactInvals offsetof(xl_xact_invals, msgs)
 
-typedef struct xl_xact_twophase
+typedef struct PG_NO_PADDING xl_xact_twophase
 {
 	TransactionId xid;
 } xl_xact_twophase;
 
-typedef struct xl_xact_origin
+typedef struct PG_NO_PADDING xl_xact_origin
 {
 	XLogRecPtr	origin_lsn;
 	TimestampTz origin_timestamp;
 } xl_xact_origin;
 
-typedef struct xl_xact_commit
+typedef struct PG_NO_PADDING xl_xact_commit
 {
 	TimestampTz xact_time;		/* time of commit */
 
@@ -334,7 +334,7 @@ typedef struct xl_xact_commit
 } xl_xact_commit;
 #define MinSizeOfXactCommit (offsetof(xl_xact_commit, xact_time) + sizeof(TimestampTz))
 
-typedef struct xl_xact_abort
+typedef struct PG_NO_PADDING xl_xact_abort
 {
 	TimestampTz xact_time;		/* time of abort */
 
diff --git a/src/include/access/xlog_internal.h b/src/include/access/xlog_internal.h
index fbc5d77ab39..a8c07b20fe5 100644
--- a/src/include/access/xlog_internal.h
+++ b/src/include/access/xlog_internal.h
@@ -33,7 +33,7 @@
  */
 #define XLOG_PAGE_MAGIC 0xD11B	/* can be used as WAL version indicator */
 
-typedef struct XLogPageHeaderData
+typedef struct PG_NO_PADDING XLogPageHeaderData
 {
 	uint16		xlp_magic;		/* magic value for correctness checks */
 	uint16		xlp_info;		/* flag bits, see below */
@@ -47,6 +47,7 @@ typedef struct XLogPageHeaderData
 	 * header.  Note that the continuation data isn't necessarily aligned.
 	 */
 	uint32		xlp_rem_len;	/* total len of remaining data for record */
+	pg_padding_4(pg_pad);
 } XLogPageHeaderData;
 
 #define SizeOfXLogShortPHD	MAXALIGN(sizeof(XLogPageHeaderData))
@@ -58,7 +59,7 @@ typedef XLogPageHeaderData *XLogPageHeader;
  * page header.  (This is ordinarily done just in the first page of an
  * XLOG file.)	The additional fields serve to identify the file accurately.
  */
-typedef struct XLogLongPageHeaderData
+typedef struct PG_NO_PADDING XLogLongPageHeaderData
 {
 	XLogPageHeaderData std;		/* standard header fields */
 	uint64		xlp_sysid;		/* system identifier from pg_control */
@@ -270,7 +271,7 @@ BackupHistoryFilePath(char *path, TimeLineID tli, XLogSegNo logSegNo, XLogRecPtr
  * Information logged when we detect a change in one of the parameters
  * important for Hot Standby.
  */
-typedef struct xl_parameter_change
+typedef struct PG_NO_PADDING xl_parameter_change
 {
 	int			MaxConnections;
 	int			max_worker_processes;
@@ -280,29 +281,31 @@ typedef struct xl_parameter_change
 	int			wal_level;
 	bool		wal_log_hints;
 	bool		track_commit_timestamp;
+	pg_padding_2(pg_pad);
 } xl_parameter_change;
 
 /* logs restore point */
-typedef struct xl_restore_point
+typedef struct PG_NO_PADDING xl_restore_point
 {
 	TimestampTz rp_time;
 	char		rp_name[MAXFNAMELEN];
 } xl_restore_point;
 
 /* Overwrite of prior contrecord */
-typedef struct xl_overwrite_contrecord
+typedef struct PG_NO_PADDING xl_overwrite_contrecord
 {
 	XLogRecPtr	overwritten_lsn;
 	TimestampTz overwrite_time;
 } xl_overwrite_contrecord;
 
 /* End of recovery mark, when we don't do an END_OF_RECOVERY checkpoint */
-typedef struct xl_end_of_recovery
+typedef struct PG_NO_PADDING xl_end_of_recovery
 {
 	TimestampTz end_time;
 	TimeLineID	ThisTimeLineID; /* new TLI */
 	TimeLineID	PrevTimeLineID; /* previous TLI we forked off from */
 	int			wal_level;
+	pg_padding_4(pg_pad);
 } xl_end_of_recovery;
 
 /*
diff --git a/src/include/access/xlogrecord.h b/src/include/access/xlogrecord.h
index e8999d3fe91..8c74998607d 100644
--- a/src/include/access/xlogrecord.h
+++ b/src/include/access/xlogrecord.h
@@ -38,14 +38,14 @@
  * XLogRecordDataHeaderLong structs all begin with a single 'id' byte. It's
  * used to distinguish between block references, and the main data structs.
  */
-typedef struct XLogRecord
+typedef struct PG_NO_PADDING XLogRecord
 {
 	uint32		xl_tot_len;		/* total len of entire record */
 	TransactionId xl_xid;		/* xact id */
 	XLogRecPtr	xl_prev;		/* ptr to previous record in log */
 	uint8		xl_info;		/* flag bits, see below */
 	RmgrId		xl_rmid;		/* resource manager for this record */
-	/* 2 bytes of padding here, initialize to zero */
+	pg_padding_2(pg_pad);
 	pg_crc32c	xl_crc;			/* CRC for this record */
 
 	/* XLogRecordBlockHeaders and XLogRecordDataHeader follow, no padding */
@@ -100,7 +100,7 @@ typedef struct XLogRecord
  * Note that we don't attempt to align the XLogRecordBlockHeader struct!
  * So, the struct must be copied to aligned local storage before use.
  */
-typedef struct XLogRecordBlockHeader
+typedef struct PG_NO_PADDING XLogRecordBlockHeader
 {
 	uint8		id;				/* block reference ID */
 	uint8		fork_flags;		/* fork within the relation, and flags */
@@ -112,7 +112,7 @@ typedef struct XLogRecordBlockHeader
 	/* BlockNumber follows */
 } XLogRecordBlockHeader;
 
-#define SizeOfXLogRecordBlockHeader (offsetof(XLogRecordBlockHeader, data_length) + sizeof(uint16))
+#define SizeOfXLogRecordBlockHeader (sizeof(XLogRecordBlockHeader))
 
 /*
  * Additional header information when a full-page image is included
@@ -138,11 +138,12 @@ typedef struct XLogRecordBlockHeader
  * compressed, the amount of block data actually present is less than
  * BLCKSZ - the length of "hole" bytes - the length of extra information.
  */
-typedef struct XLogRecordBlockImageHeader
+typedef struct PG_NO_PADDING XLogRecordBlockImageHeader
 {
 	uint16		length;			/* number of page image bytes */
 	uint16		hole_offset;	/* number of bytes before "hole" */
 	uint8		bimg_info;		/* flag bits, see below */
+	pg_padding_1(pg_pad);
 
 	/*
 	 * If BKPIMAGE_HAS_HOLE and BKPIMAGE_COMPRESSED(), an
@@ -151,7 +152,7 @@ typedef struct XLogRecordBlockImageHeader
 } XLogRecordBlockImageHeader;
 
 #define SizeOfXLogRecordBlockImageHeader	\
-	(offsetof(XLogRecordBlockImageHeader, bimg_info) + sizeof(uint8))
+	(sizeof(XLogRecordBlockImageHeader))
 
 /* Information stored in bimg_info */
 #define BKPIMAGE_HAS_HOLE		0x01	/* page image has "hole" */
@@ -170,7 +171,7 @@ typedef struct XLogRecordBlockImageHeader
  * Extra header information used when page image has "hole" and
  * is compressed.
  */
-typedef struct XLogRecordBlockCompressHeader
+typedef struct PG_NO_PADDING XLogRecordBlockCompressHeader
 {
 	uint16		hole_length;	/* number of bytes in "hole" */
 } XLogRecordBlockCompressHeader;
@@ -210,7 +211,7 @@ typedef struct XLogRecordBlockCompressHeader
  * (These structs are currently not used in the code, they are here just for
  * documentation purposes).
  */
-typedef struct XLogRecordDataHeaderShort
+typedef struct PG_NO_PADDING XLogRecordDataHeaderShort
 {
 	uint8		id;				/* XLR_BLOCK_ID_DATA_SHORT */
 	uint8		data_length;	/* number of payload bytes */
@@ -218,7 +219,7 @@ typedef struct XLogRecordDataHeaderShort
 
 #define SizeOfXLogRecordDataHeaderShort (sizeof(uint8) * 2)
 
-typedef struct XLogRecordDataHeaderLong
+typedef struct PG_NO_PADDING XLogRecordDataHeaderLong
 {
 	uint8		id;				/* XLR_BLOCK_ID_DATA_LONG */
 	/* followed by uint32 data_length, unaligned */
diff --git a/src/include/catalog/pg_control.h b/src/include/catalog/pg_control.h
index 7503db1af51..9e745b14177 100644
--- a/src/include/catalog/pg_control.h
+++ b/src/include/catalog/pg_control.h
@@ -32,7 +32,7 @@
  * a copy of the latest one in pg_control for possible disaster recovery.
  * Changing this struct requires a PG_CONTROL_VERSION bump.
  */
-typedef struct CheckPoint
+typedef struct PG_NO_PADDING CheckPoint
 {
 	XLogRecPtr	redo;			/* next RecPtr available when we began to
 								 * create CheckPoint (i.e. REDO start point) */
@@ -40,8 +40,13 @@ typedef struct CheckPoint
 	TimeLineID	PrevTimeLineID; /* previous TLI, if this record begins a new
 								 * timeline (equals ThisTimeLineID otherwise) */
 	bool		fullPageWrites; /* current full_page_writes */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	int			wal_level;		/* current wal_level */
 	bool		logicalDecodingEnabled; /* current logical decoding status */
+	pg_padding_1(pg_pad3);
+	pg_padding_2(pg_pad4);
+	pg_padding_4(pg_pad5);
 	FullTransactionId nextXid;	/* next free transaction ID */
 	Oid			nextOid;		/* next free OID */
 	MultiXactId nextMulti;		/* next free MultiXactId */
@@ -63,6 +68,7 @@ typedef struct CheckPoint
 	 * set to InvalidTransactionId.
 	 */
 	TransactionId oldestActiveXid;
+	pg_padding_4(pg_pad6);
 } CheckPoint;
 
 /* XLOG info values for XLOG rmgr */
diff --git a/src/include/catalog/storage_xlog.h b/src/include/catalog/storage_xlog.h
index c1b2f736669..89b1bfeef6e 100644
--- a/src/include/catalog/storage_xlog.h
+++ b/src/include/catalog/storage_xlog.h
@@ -30,7 +30,7 @@
 #define XLOG_SMGR_CREATE	0x10
 #define XLOG_SMGR_TRUNCATE	0x20
 
-typedef struct xl_smgr_create
+typedef struct PG_NO_PADDING xl_smgr_create
 {
 	RelFileLocator rlocator;
 	ForkNumber	forkNum;
@@ -43,7 +43,7 @@ typedef struct xl_smgr_create
 #define SMGR_TRUNCATE_ALL		\
 	(SMGR_TRUNCATE_HEAP|SMGR_TRUNCATE_VM|SMGR_TRUNCATE_FSM)
 
-typedef struct xl_smgr_truncate
+typedef struct PG_NO_PADDING xl_smgr_truncate
 {
 	BlockNumber blkno;
 	RelFileLocator rlocator;
diff --git a/src/include/commands/dbcommands_xlog.h b/src/include/commands/dbcommands_xlog.h
index 4ff3d0c82c9..04c4f35c160 100644
--- a/src/include/commands/dbcommands_xlog.h
+++ b/src/include/commands/dbcommands_xlog.h
@@ -26,7 +26,7 @@
  * Single WAL record for an entire CREATE DATABASE operation. This is used
  * by the FILE_COPY strategy.
  */
-typedef struct xl_dbase_create_file_copy_rec
+typedef struct PG_NO_PADDING xl_dbase_create_file_copy_rec
 {
 	Oid			db_id;
 	Oid			tablespace_id;
@@ -39,13 +39,13 @@ typedef struct xl_dbase_create_file_copy_rec
  * WAL_LOG strategy is used. Each individual block will be logged separately
  * afterward.
  */
-typedef struct xl_dbase_create_wal_log_rec
+typedef struct PG_NO_PADDING xl_dbase_create_wal_log_rec
 {
 	Oid			db_id;
 	Oid			tablespace_id;
 } xl_dbase_create_wal_log_rec;
 
-typedef struct xl_dbase_drop_rec
+typedef struct PG_NO_PADDING xl_dbase_drop_rec
 {
 	Oid			db_id;
 	int			ntablespaces;	/* number of tablespace IDs */
diff --git a/src/include/commands/sequence_xlog.h b/src/include/commands/sequence_xlog.h
index b0495f41b43..81685f6bf04 100644
--- a/src/include/commands/sequence_xlog.h
+++ b/src/include/commands/sequence_xlog.h
@@ -31,7 +31,7 @@ typedef struct sequence_magic
 } sequence_magic;
 
 /* Sequence WAL record */
-typedef struct xl_seq_rec
+typedef struct PG_NO_PADDING xl_seq_rec
 {
 	RelFileLocator locator;
 	/* SEQUENCE TUPLE DATA FOLLOWS AT THE END */
diff --git a/src/include/commands/tablespace.h b/src/include/commands/tablespace.h
index 4fa85c2906b..f4e0be425ba 100644
--- a/src/include/commands/tablespace.h
+++ b/src/include/commands/tablespace.h
@@ -27,13 +27,13 @@ extern PGDLLIMPORT bool allow_in_place_tablespaces;
 #define XLOG_TBLSPC_CREATE		0x00
 #define XLOG_TBLSPC_DROP		0x10
 
-typedef struct xl_tblspc_create_rec
+typedef struct PG_NO_PADDING xl_tblspc_create_rec
 {
 	Oid			ts_id;
 	char		ts_path[FLEXIBLE_ARRAY_MEMBER]; /* null-terminated string */
 } xl_tblspc_create_rec;
 
-typedef struct xl_tblspc_drop_rec
+typedef struct PG_NO_PADDING xl_tblspc_drop_rec
 {
 	Oid			ts_id;
 } xl_tblspc_drop_rec;
diff --git a/src/include/replication/message.h b/src/include/replication/message.h
index d1c72755084..574ae407406 100644
--- a/src/include/replication/message.h
+++ b/src/include/replication/message.h
@@ -17,10 +17,12 @@
 /*
  * Generic logical decoding message wal record.
  */
-typedef struct xl_logical_message
+typedef struct PG_NO_PADDING xl_logical_message
 {
 	Oid			dbId;			/* database Oid emitted from */
 	bool		transactional;	/* is message transactional? */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	Size		prefix_size;	/* length of prefix */
 	Size		message_size;	/* size of the message */
 	/* payload, including null-terminated prefix of length prefix_size */
diff --git a/src/include/replication/origin.h b/src/include/replication/origin.h
index eb46b41b4b7..f7c7ee58bd9 100644
--- a/src/include/replication/origin.h
+++ b/src/include/replication/origin.h
@@ -15,14 +15,16 @@
 #include "access/xlogreader.h"
 #include "catalog/pg_replication_origin.h"
 
-typedef struct xl_replorigin_set
+typedef struct PG_NO_PADDING xl_replorigin_set
 {
 	XLogRecPtr	remote_lsn;
 	ReplOriginId node_id;
 	bool		force;
+	pg_padding_1(pg_pad1);
+	pg_padding_4(pg_pad2);
 } xl_replorigin_set;
 
-typedef struct xl_replorigin_drop
+typedef struct PG_NO_PADDING xl_replorigin_drop
 {
 	ReplOriginId node_id;
 } xl_replorigin_drop;
diff --git a/src/include/storage/lockdefs.h b/src/include/storage/lockdefs.h
index b73bb5618e6..ea95983f1e2 100644
--- a/src/include/storage/lockdefs.h
+++ b/src/include/storage/lockdefs.h
@@ -51,7 +51,7 @@ typedef int LOCKMODE;
 #define InplaceUpdateTupleLock ExclusiveLock
 
 /* WAL representation of an AccessExclusiveLock on a table */
-typedef struct xl_standby_lock
+typedef struct PG_NO_PADDING xl_standby_lock
 {
 	TransactionId xid;			/* xid of holder of AccessExclusiveLock */
 	Oid			dbOid;			/* DB containing table */
diff --git a/src/include/storage/sinval.h b/src/include/storage/sinval.h
index 4d33fdcabe1..d66a095f0ea 100644
--- a/src/include/storage/sinval.h
+++ b/src/include/storage/sinval.h
@@ -58,34 +58,40 @@
  * sent immediately when the underlying file change is made.
  */
 
-typedef struct
+typedef struct SharedInvalCatcacheMsg
 {
 	int8		id;				/* cache ID --- must be first */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	Oid			dbId;			/* database ID, or 0 if a shared relation */
 	uint32		hashValue;		/* hash value of key for this catcache */
 } SharedInvalCatcacheMsg;
 
 #define SHAREDINVALCATALOG_ID	(-1)
 
-typedef struct
+typedef struct SharedInvalCatalogMsg
 {
 	int8		id;				/* type field --- must be first */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	Oid			dbId;			/* database ID, or 0 if a shared catalog */
 	Oid			catId;			/* ID of catalog whose contents are invalid */
 } SharedInvalCatalogMsg;
 
 #define SHAREDINVALRELCACHE_ID	(-2)
 
-typedef struct
+typedef struct SharedInvalRelcacheMsg
 {
 	int8		id;				/* type field --- must be first */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	Oid			dbId;			/* database ID, or 0 if a shared relation */
 	Oid			relId;			/* relation ID, or 0 if whole relcache */
 } SharedInvalRelcacheMsg;
 
 #define SHAREDINVALSMGR_ID		(-3)
 
-typedef struct
+typedef struct SharedInvalSmgrMsg
 {
 	/* note: field layout chosen to pack into 16 bytes */
 	int8		id;				/* type field --- must be first */
@@ -96,32 +102,38 @@ typedef struct
 
 #define SHAREDINVALRELMAP_ID	(-4)
 
-typedef struct
+typedef struct SharedInvalRelmapMsg
 {
 	int8		id;				/* type field --- must be first */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	Oid			dbId;			/* database ID, or 0 for shared catalogs */
 } SharedInvalRelmapMsg;
 
 #define SHAREDINVALSNAPSHOT_ID	(-5)
 
-typedef struct
+typedef struct SharedInvalSnapshotMsg
 {
 	int8		id;				/* type field --- must be first */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	Oid			dbId;			/* database ID, or 0 if a shared relation */
 	Oid			relId;			/* relation ID */
 } SharedInvalSnapshotMsg;
 
 #define SHAREDINVALRELSYNC_ID	(-6)
 
-typedef struct
+typedef struct SharedInvalRelSyncMsg
 {
 	int8		id;				/* type field --- must be first */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	Oid			dbId;			/* database ID */
 	Oid			relid;			/* relation ID, or 0 if whole
 								 * RelationSyncCache */
 } SharedInvalRelSyncMsg;
 
-typedef union
+typedef union SharedInvalidationMessage
 {
 	int8		id;				/* type field --- must be first */
 	SharedInvalCatcacheMsg cc;
